varying vec3 v_v3ViewDir;
varying vec3 v_v3LightDir;
varying vec3 v_v3Normal;
uniform float u_fTime;
uniform vec3 u_v3Camera;
attribute vec3 a_vTangent; 


void main(void)
{
	// transform and calculate normal, tangent and binormal
	vec3 n = normalize(gl_NormalMatrix * gl_Normal);
	vec3 t = normalize(gl_NormalMatrix * a_vTangent);
	vec3 b = cross(n, t);

	// transform vertexposition and lightdirection
	gl_ClipVertex     = gl_ModelViewMatrix * gl_Vertex;
	vec3 MathPosition = gl_ClipVertex.xyz;
	vec3 MathLightDir = gl_LightSource[0].position.xyz;

	// dot3-transform the lightdirection
	v_v3LightDir.x = dot(MathLightDir, t);
	v_v3LightDir.y = dot(MathLightDir, b);
	v_v3LightDir.z = dot(MathLightDir, n);
	v_v3LightDir   = normalize(v_v3LightDir);

	// dot3-transform the viewdirection
	v_v3ViewDir.x = dot(MathPosition, t);
	v_v3ViewDir.y = dot(MathPosition, b);
	v_v3ViewDir.z = dot(MathPosition, n);
	v_v3ViewDir   = normalize(v_v3ViewDir);

	// save transformed normal
	v_v3Normal = n;

	// fixed vertex transformation
	gl_Position = ftransform();

	// calculate texture-coordinates
	vec2 v2CamOffset = gl_Vertex.xz + u_v3Camera.xz;
	gl_TexCoord[0]   = vec4(v2CamOffset.x+u_fTime,      v2CamOffset.y+u_fTime,      0.0f, 0.0f) * 0.010f;
	gl_TexCoord[1]   = vec4(v2CamOffset.x+u_fTime*0.5f, v2CamOffset.y-u_fTime*0.3f, 0.0f, 0.0f) * 0.125f;
	gl_TexCoord[2]   = vec4(v2CamOffset.x+u_fTime*0.2f, v2CamOffset.y+u_fTime*0.8f, 0.0f, 0.0f) * 1.500f;
}